SORT(1)

NAME
sort - sort or merge files

SYNOPSIS

sort [-mubdfiMnrtx] [+pos1 [-pos2]] ... [-k keydef] [-o name] [-T directory] [-y[kmem]] [-z recsz] [name] ...

DESCRIPTION
Sort sorts lines of all the named files together and writes the result on the standard output. The name `-' means the standard input. If no input files are named, the standard input is sorted.

The default sort key is an entire line. Default ordering is lexicographic by characters in the current collating sequence.

The behavior of sort is altered by the following options:

-c  Check that the input file is sorted according to the ordering rules, give no output unless the file is out of sort. Only one input file may be given.

-m  Merge only, the input files are already sorted.

-o file
    The file argument is the name of an output file to use instead of the standard output. This file may be the same as one of the inputs.

-T tmpdir
    The tmpdir argument is the name of a directory in which temporary files should be made.

-u  Suppress all but one in each set of equal lines. Ignored bytes and bytes outside keys do not participate in this comparison.

-y[kmem]
    Sets the amount of memory to be allocated initially to kmem (in kilobytes). If kmem is omitted or is larger than the maximum allowed value, a maximum value is used. If kmem is 0 or is smaller than the minimum allowed value, a minimum value is used. More memory is allocated during the sort phase if a line exceeds the expected length.

-z recsz
    Sets the length of the maximum allowed line during the merge phase to recsz. The length of lines is normally computed during the sort phase, so this option is relevant only if the sort phase is omitted (with -c or -m).

The ordering is affected globally by the following options, one or more of which may appear.

-b  Ignore leading blanks (spaces and tabs) in field comparisons.

-d  `Dictionary' order: only letters, digits and blanks are significant in comparisons.

-f  Fold upper case letters onto lower case.

-i  Ignore nonprintable characters in nonnumeric comparisons.

-M  Compare the first three characters of the field without regard to case as abbreviated month names `JAN', `FEB', `MAR' etc. Invalid fields compare to `JAN'. Implies option -b.

-n  An initial numeric string, consisting of optional blanks, optional minus sign, and zero or more digits with optional decimal point and optional thousands separators, is sorted by arithmetic value.

-r  Reverse the sense of comparisons.

-tx `Tab character' separating fields is x. With /usr/local/heirloom/usr/5bin/sort and /usr/local/heirloom/usr/5bin/s42/sort, the x argument is optional; if it is missing, the field separator is reset to the default.

The notation +pos1 -pos2 restricts a sort key to a field beginning at pos1 and ending just before pos2. Pos1 and pos2 each have the form m.n, optionally followed by one or more of the flags bdfiMnr, where m tells a number of fields to skip from the beginning of the line and n tells a number of characters to skip further. If any flags are present they override all the global ordering options for this key. If the -b option is in effect n is counted from the first nonblank in the field; -b is attached independently to pos2. A missing .n means .0; a missing -pos2 means the end of the line. Under the -tx option, fields are strings separated by x; otherwise fields are nonempty nonblank strings separated by blanks.

When there are multiple sort keys, later keys are compared only after all earlier keys compare equal. Lines that otherwise compare equal are ordered with all bytes significant.

The -k keydef option, which was introduced by POSIX.2, provides another method to specify sort keys. Start field and end field are separated by commas, field and character numbers start at 1 instead of 0, and, if no character position is specified for the end key, the last character of the field is used; otherwise, the meaning of field specifications is identical.

EXAMPLES
Print in alphabetical order all the unique spellings in a list of words. Capitalized words differ from uncapitalized.

sort -u +0f +0 list

Print the password file (passwd(5)) sorted by user id number (the 3rd colon-separated field).

sort -t: +2n /etc/passwd

Print the first instance of each month in an already sorted file of (month day) entries. The options -um with just one input file make the choice of a unique representative from a set of equal lines predictable.

sort -um +0 -1 dates

ENVIRONMENT VARIABLES

LANG, LC_ALL
    See locale(7).

LC_COLLATE
    Gives the sort order for comparing strings.

LC_CTYPE
    Determines the mapping of bytes to characters and the character types for the b, d, f, and i field options.

LC_NUMERIC
    Affects the radix and thousands separator characters for the -n option.

LC_TIME
    Sets the month names used with -M.

TMPDIR
    Specifies a directory to use for temporary files.

FILES

/var/tmp/stm*, /tmp/*
    first and second tries for temporary files

SEE ALSO
comm(1), join(1), uniq(1), locale(7)

DIAGNOSTICS
Comments and exits with nonzero status for various trouble conditions and for disorder discovered under option -c.

NOTES
Maximum performance is usually achieved if the TMPDIR environment variable is set to a directory on a tmpfs file system, and the -y option is given.